"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = test;

var path = _interopRequireWildcard(require("path"));

var _resolve = _interopRequireDefault(require("resolve"));

var _getModularRoot = _interopRequireDefault(require("./getModularRoot"));

var _execSync = _interopRequireDefault(require("./execSync"));

var _resolveAsBin = _interopRequireDefault(require("resolve-as-bin"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const jestBin = (0, _resolveAsBin.default)('jest');

function test(args) {
  if (process.env.SKIP_PREFLIGHT_CHECK !== 'true') {
    const verifyPackageTree = require('react-scripts/scripts/utils/verifyPackageTree'); // eslint-disable-line @typescript-eslint/no-var-requires


    verifyPackageTree();
  }

  const modularRoot = (0, _getModularRoot.default)();
  let argv = process.argv.slice(3).concat(['--config', path.join(__dirname, '..', 'jest-config.js')]); // Watch unless on CI or explicitly running all tests

  if (!process.env.CI && args.indexOf('--watchAll=false') === -1) {
    // https://github.com/facebook/create-react-app/issues/5210
    argv.push('--watchAll');
  } // via https://github.com/facebook/create-react-app/blob/master/packages/react-scripts/scripts/test.js
  // This is a very dirty workaround for https://github.com/facebook/jest/issues/5913.
  // We're trying to resolve the environment ourselves because Jest does it incorrectly.
  // TODO: remove this as soon as it's fixed in Jest.


  function resolveJestDefaultEnvironment(name) {
    const jestDir = path.dirname(_resolve.default.sync('jest', {
      basedir: __dirname
    }));
    const jestCLIDir = path.dirname(_resolve.default.sync('jest-cli', {
      basedir: jestDir
    }));
    const jestConfigDir = path.dirname(_resolve.default.sync('jest-config', {
      basedir: jestCLIDir
    }));
    return _resolve.default.sync(name, {
      basedir: jestConfigDir
    });
  }

  const cleanArgv = [];
  let env = 'jsdom';
  let next;

  do {
    var _next;

    next = argv.shift();

    if (next === '--env') {
      env = argv.shift();
    } else if (((_next = next) === null || _next === void 0 ? void 0 : _next.indexOf('--env=')) === 0) {
      env = next.substring('--env='.length);
    } else {
      cleanArgv.push(next);
    }
  } while (argv.length > 0); // @ts-ignore


  argv = cleanArgv;
  let resolvedEnv;

  try {
    resolvedEnv = resolveJestDefaultEnvironment(`jest-environment-${env}`);
  } catch (e) {// ignore
  }

  if (!resolvedEnv) {
    try {
      resolvedEnv = resolveJestDefaultEnvironment(env);
    } catch (e) {// ignore
    }
  }

  const testEnvironment = resolvedEnv || env;
  argv.push('--env', testEnvironment || ''); // ends the section copied from CRA

  let testBin = jestBin,
      testArgs = argv;

  if (argv.includes('--inspect-brk')) {
    // If we're trying to attach to a debugger, we need to run node
    // instead. This moves around the command line arguments for so.
    testBin = 'node';
    testArgs = ['--inspect-brk', jestBin, ...testArgs.filter(x => x !== '--inspect-brk')];
  }

  (0, _execSync.default)(testBin, testArgs, {
    cwd: modularRoot,
    log: false,
    // @ts-ignore
    env: {
      BABEL_ENV: 'test',
      NODE_ENV: 'test',
      PUBLIC_URL: '',
      MODULAR_ROOT: modularRoot
    }
  });
  return Promise.resolve();
}